﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace WindowsFormsApplication4
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

      this.WindowState = FormWindowState.Maximized;
      this.AutoScroll = true;

      InitializeChart();
    }

    private Steema.TeeChart.Styles.FastLine[] fs;
    private Steema.TeeChart.Axis[] myAxis;
    private Steema.TeeChart.TChart tchart1;

    private void InitializeChart()
    {
      tchart1 = new Steema.TeeChart.TChart();

      tchart1.AllowDrop = true;
      tchart1.Aspect.View3D = false;
      tchart1.Dock = DockStyle.Top;
      tchart1.Aspect.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
      tchart1.Aspect.TextRenderingHint = System.Drawing.Text.TextRenderingHint.ClearTypeGridFit;

      // Now cursor tool
      Steema.TeeChart.Tools.CursorTool cursorTool1 = new Steema.TeeChart.Tools.CursorTool(tchart1.Chart);

      cursorTool1.FollowMouse = true;
      cursorTool1.FastCursor = true;
      cursorTool1.Pen.Style = System.Drawing.Drawing2D.DashStyle.Solid;
      cursorTool1.Style = Steema.TeeChart.Tools.CursorToolStyles.Vertical;
      cursorTool1.Pen.Color = Color.Orange;
      cursorTool1.Pen.Width = 1;

      tchart1.Panel.MarginLeft = 30;

      fs = new Steema.TeeChart.Styles.FastLine[128];
      myAxis = new Steema.TeeChart.Axis[128];

      // Now fast lines
      for (int i = 0; i <= 50; i++)
      {
        // fastlines
        fs[i] = new Steema.TeeChart.Styles.FastLine(tchart1.Chart);
        fs[i].FillSampleValues(18000);
        fs[i].DrawAllPoints = false;
        tchart1.Height += 56;

        // axis
        myAxis[i] = new Steema.TeeChart.Axis(tchart1.Chart);
        myAxis[i].StartEndPositionUnits = Steema.TeeChart.PositionUnits.Pixels;
        myAxis[i].Automatic = true;
        myAxis[i].Title.TextAlign = StringAlignment.Near;
        myAxis[i].Title.Text = ("Axis_" + i);

        if (i == 0)
        {
          myAxis[i].StartPosition = 0;
          myAxis[i].EndPosition = 55;
        }
        else
        {
          myAxis[i].StartPosition = myAxis[i - 1].EndPosition + 5;
          myAxis[i].EndPosition = myAxis[i].StartPosition + 50;
        }

        fs[i].CustomVertAxis = myAxis[i];
        tchart1.Axes.Custom.Add(myAxis[i]);
      }

      this.Controls.Add(tchart1);

      tchart1.DragDrop +=new DragEventHandler(tchart1_DragDrop);
      tchart1.DragEnter +=new DragEventHandler(tchart1_DragEnter);
    }

    private void tchart1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
    {
      Steema.TeeChart.TChart tmpChart = (Steema.TeeChart.TChart)sender;
      Steema.TeeChart.Axis dragDropAxis;

      int tmp = this.AutoScrollPosition.Y;

      for (int i = 0; i < tmpChart.Axes.Custom.Count; i++)
      {
        dragDropAxis = tmpChart.Axes.Custom[i];
        if (!dragDropAxis.Horizontal && 
            ((dragDropAxis.IStartPos + tmp <= e.Y) && (dragDropAxis.IEndPos + tmp >= e.Y)))
        {
          MessageBox.Show("Dropped on " + dragDropAxis.Title.Text);
          break;
        }
      }
    }

    private void tchart1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
    {
      if (e.Data.GetDataPresent("FileDrop"))
      {
        e.Effect = DragDropEffects.Copy;
      }
    }

	}
}
